"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLargestStringLength = exports.format = void 0;
const pad_js_1 = require("./pad.js");
exports.format = {
    counter: (current, total, pad = '0') => {
        const totalDigits = String(total).length;
        return (0, pad_js_1.padStart)(String(current), totalDigits, pad);
    },
    dim: (value) => `\x1b[2m${value}\x1b[0m`,
    bold: (value) => `\x1b[1m${value}\x1b[0m`,
    underline: (value) => `\x1b[4m${value}\x1b[0m`,
    info: (value) => `\x1b[94m${value}\x1b[0m`,
    italic: (value) => `\x1b[3m${value}\x1b[0m`,
    success: (value) => `\x1b[32m${value}\x1b[0m`,
    fail: (value) => `\x1b[91m${value}\x1b[0m`,
    bg: (bg, text) => {
        const padding = ' '.repeat(1);
        const paddedText = `${padding}${text}${padding}`;
        return `\x1b[${bg}m\x1b[1m${paddedText}\x1b[0m`;
    },
};
const getLargestStringLength = (arr) => arr.reduce((max, current) => Math.max(max, current.length), 0);
exports.getLargestStringLength = getLargestStringLength;
