"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertPromise = void 0;
const nodeAssert = __importStar(require("assert"));
const parseAsssetion_js_1 = require("../helpers/parseAsssetion.js");
const assert_js_1 = require("./assert.js");
const ok = (value, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.ok(value), { message });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const equal = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.equal(actual, expected), { message });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const deepEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.deepEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const strictEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.strictEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const deepStrictEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.deepStrictEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const doesNotMatch = (value, regExp, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.doesNotMatch(value, regExp), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
function doesNotReject(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                yield nodeAssert.doesNotReject(block, errorOrMessage);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message,
                    defaultMessage: 'Got unwanted rejection',
                    hideDiff: true,
                    throw: true,
                });
            }
        }
        else {
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                yield nodeAssert.doesNotReject(block);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error_1) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error_1;
                }, {
                    message: typeof errorOrMessage === 'string' ? errorOrMessage : undefined,
                    defaultMessage: 'Got unwanted rejection',
                    hideDiff: true,
                    throw: true,
                });
            }
        }
    });
}
function doesNotThrow(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                nodeAssert.doesNotThrow(block, errorOrMessage, message);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message: message,
                    defaultMessage: 'Expected function not to throw',
                    hideDiff: true,
                    throw: true,
                });
            }
        }
        else {
            const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                nodeAssert.doesNotThrow(block, msg);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message: msg,
                    defaultMessage: 'Expected function not to throw',
                    hideDiff: true,
                    throw: true,
                });
            }
        }
    });
}
function throws(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                nodeAssert.throws(block, errorOrMessage, message);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message: message,
                    defaultMessage: 'Expected function to throw',
                    hideDiff: true,
                });
            }
        }
        else {
            const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                nodeAssert.throws(block, message);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message: msg,
                    defaultMessage: 'Expected function to throw',
                    hideDiff: true,
                });
            }
        }
    });
}
const notEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const notDeepEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notDeepEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const notStrictEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notStrictEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const notDeepStrictEqual = (actual, expected, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.notDeepStrictEqual(actual, expected), {
        message,
    });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const match = (value, regExp, message) => __awaiter(void 0, void 0, void 0, function* () {
    if (assert_js_1.each.before)
        yield assert_js_1.each.before();
    (0, parseAsssetion_js_1.parseAssertion)(() => nodeAssert.match(value, regExp), { message });
    if (assert_js_1.each.after)
        yield assert_js_1.each.after();
});
const ifError = (value) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        if (assert_js_1.each.before)
            yield assert_js_1.each.before();
        nodeAssert.ifError(value);
        if (assert_js_1.each.after)
            yield assert_js_1.each.after();
    }
    catch (error) {
        (0, parseAsssetion_js_1.parseAssertion)(() => {
            throw error;
        }, {
            defaultMessage: 'Expected no error, but received an error',
            hideDiff: true,
            throw: true,
        });
    }
});
const fail = (message) => {
    try {
        nodeAssert.fail(message);
    }
    catch (error) {
        (0, parseAsssetion_js_1.parseAssertion)(() => {
            throw error;
        }, {
            message,
            defaultMessage: 'Test failed intentionally',
            hideDiff: true,
        });
    }
};
function rejects(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                yield nodeAssert.rejects(block, errorOrMessage);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error;
                }, {
                    message,
                    defaultMessage: 'Expected promise to be rejected with specified error',
                    hideDiff: true,
                });
            }
        }
        else {
            const msg = typeof errorOrMessage === 'string' ? errorOrMessage : undefined;
            try {
                if (assert_js_1.each.before)
                    yield assert_js_1.each.before();
                yield nodeAssert.rejects(block);
                if (assert_js_1.each.after)
                    yield assert_js_1.each.after();
            }
            catch (error_1) {
                (0, parseAsssetion_js_1.parseAssertion)(() => {
                    throw error_1;
                }, {
                    message: msg,
                    defaultMessage: 'Expected promise to be rejected',
                    hideDiff: true,
                });
            }
        }
    });
}
exports.assertPromise = Object.assign((value, message) => ok(value, message), {
    ok,
    equal,
    deepEqual,
    strictEqual,
    deepStrictEqual,
    doesNotMatch,
    doesNotReject,
    throws,
    doesNotThrow,
    notEqual,
    notDeepEqual,
    notStrictEqual,
    notDeepStrictEqual,
    match,
    ifError,
    fail,
    rejects,
});
